/*
Copyright (C) 2011-2014 Baker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
// timelib.h -- time functions

#define CORE_LOCAL
#include "core.h"


///////////////////////////////////////////////////////////////////////////////
//  CORE: Time functions
///////////////////////////////////////////////////////////////////////////////


int Time_Minutes (int seconds)
{
	return seconds / 60;
}

int Time_Seconds (int seconds)
{
	return seconds %60;
}


double Time_Now (void)
{
	return System_Time ();
}

void Time_Sleep (unsigned long milliseconds)
{
	System_Sleep (milliseconds);
}

void Time_Wait (double seconds)
{
	double end_time = Time_Now () + seconds;
	
	while (Time_Now() < end_time)
	{
		Time_Sleep (1);
	}
}


